#include "buildingeditordialog.h"
#include "buildingdelegate.h"
#include "ui_buildingeditordialog.h"

#include <QMessageBox>
#include <QSqlQuery>

BuildingEditorDialog::BuildingEditorDialog(QWidget *parent) :
        QWidget(parent),
        _ui(new Ui::BuildingEditorDialog)
{
    _ui->setupUi(this);

    _model = new BuildingTableModel(this);
    _model->select();

    setupFilter();
    setupUi();
}

BuildingEditorDialog::~BuildingEditorDialog()
{
    delete _ui;
    delete _model;
}

void BuildingEditorDialog::filterButton_Clicked()
{
    if (_ui->filterButton->text() == trUtf8("Szűrés") && (_ui->nameLineEdit->text() != "" || _ui->cityComboBox->currentText() != "mind")) // ha a modell nincs szűrve, és akarunk szűrni
    {
        _ui->nameLineEdit->setEnabled(false);
        _ui->cityComboBox->setEnabled(false);
        _ui->filterButton->setText(trUtf8("Szűrő törlése"));

        QString filterString = "building.name LIKE '%" + _ui->nameLineEdit->text() + "%'"; // összeállíítjuk a feltételt
        if (_ui->cityComboBox->currentText() != "mind")
        {
            QSqlQuery query;
            query.exec("select id from city where name = '" + _ui->cityComboBox->currentText() + "'");
            if (query.next())
                filterString += " AND city_id = " + query.value(0).toString(); // összeállítjuk a feltételt
        }
        _model->setFilter(filterString); // szűrés végrehajtása
    }
    else
    {
        _ui->nameLineEdit->setEnabled(true);
        _ui->cityComboBox->setEnabled(true);
        _ui->filterButton->setText(trUtf8("Szűrés"));
        _model->setFilter(""); // töröljük a szűrőt
    }
}

void BuildingEditorDialog::setupFilter()
{
    QSqlQuery query;
    query.exec("select name from city");

    _ui->cityComboBox->addItem("mind"); // összes város felvétele
    while (query.next())
    {
        _ui->cityComboBox->addItem(query.value(0).toString()); // egy város felvétele
    }
}

void BuildingEditorDialog::setupUi()
{
    _ui->tableView->setModel(_model);
    _ui->tableView->resizeColumnsToContents();
    _ui->tableView->setSelectionBehavior(QAbstractItemView::SelectRows); // teljes sor kijelölése
    _ui->tableView->setEditTriggers(QAbstractItemView::NoEditTriggers); // a táblaszerkesztés kikapcsolása a megjelenítőn
    _ui->tableView->setItemDelegate(new BuildingDelegate());
    _ui->tableView->setColumnHidden(0, true);

    connect(_ui->filterButton, SIGNAL(clicked()), this, SLOT(filterButton_Clicked()));

    setWindowTitle(trUtf8("Épületek szűrése"));
    setFixedSize(600, 400);
}
